require_dependency "easy_reports/application_controller"

module EasyReports
  class DatabasesController < ApplicationController
    before_action :set_database, only: [:show, :edit, :update, :destroy]

    def index
      @databases = Database.all
    end

    def show
    end

    def new
      @database = Database.new
    end

    def edit
    end

    def create
      @database = Database.new(database_params)

      if @database.save
        redirect_to @database, notice: 'Database was successfully created.'
      else
        render :new
      end
    end

    def update
      if @database.update(database_params)
        redirect_to @database, notice: 'Database was successfully updated.'
      else
        render :edit
      end
    end

    def destroy
      @database.destroy
      redirect_to databases_url, notice: 'Database was successfully destroyed.'
    end

    private
      def set_database
        @database = Database.find(params[:id])
      end

      def database_params
        params.require(:database).permit(:adapter, :encoding, :pool, :username, :password, :host, :name, :port)
      end
  end
end
