require_dependency "easy_reports/application_controller"

module EasyReports
  class ReportsController < ApplicationController
    before_action :set_report, only: [:show, :edit, :update, :destroy]

    def index
      @reports = Report.all

      database_mediator = EasyReports::DatabaseMediator.new
      @table_list = database_mediator.tables
    end

    def new
      @report_form = ReportForm.new
    end

    def create
      @report_form = ReportForm.new(report_params)

      if @report_form.save
        redirect_to @report_form, notice: 'Report was successfully created.'
      else
        render :new
      end
    end


    def show
    end

    def edit
    end

    def update
      if @report.update(report_params)
        redirect_to @report, notice: 'Report was successfully updated.'
      else
        render :edit
      end
    end

    def destroy
      @report.destroy
      redirect_to reports_url, notice: 'Report was successfully destroyed.'
    end

    private
      def set_report
        @report = Report.find(params[:id])
      end

      def report_params
        params.require(:report).permit(:title, :description)
      end
  end
end
